/*************/
/* Hello.cpp */
/*************/

//#include "kosSyst.h"
//#include "kosFile.h"


char kos_Header[36] = "KolibriOS Header";
const char header[] = "MSVC Hello Programm!";
const char string[] = "Hello, World!";

typedef unsigned __int32 Dword;
typedef unsigned __int16 Word;
typedef unsigned __int8 Byte;

void kos_WindowRedrawStatus(Dword status)
{
    __asm
    {
        mov eax, 12
        mov ebx, status
        int 0x40
    }
}

void kos_DefineAndDrawWindow(Word x, Word y, Word sizeX, Word sizeY, Byte mainAreaType,
                             Dword mainAreaColour, Byte headerType, Dword headerColour,
                             Dword borderColour)
{
    Dword arg1, arg2, arg3, arg4;

    arg1 = (x << 16) + sizeX;
    arg2 = (y << 16) + sizeY;
    arg3 = (mainAreaType << 24) | mainAreaColour;
    arg4 = (headerType << 24) | headerColour;

    __asm
    {
        xor eax, eax
        mov ebx, arg1
        mov ecx, arg2
        mov edx, arg3
        mov esi, arg4
        mov edi, borderColour
        int 0x40
    }
}

void kos_WriteTextToWindow(Word x, Word y, Byte fontType,
                           Dword textColour, char *textPtr, Dword textLen)
{
    Dword arg1, arg2;

    arg1 = (x << 16) | y;
    arg2 = (fontType << 24) | textColour;

    __asm
    {
        xor eax, eax 
        mov ebx, arg1
        mov ecx, arg2
        mov edx, textPtr
        mov esi, textLen
	add eax, 4
        int 0x40
    }
}

Dword kos_WaitForEvent()
{
    __asm
    {
        mov eax, 10
        int 0x40
    }
}

int kos_GetKey(Byte *keyCode)
{
    Dword result;

    __asm
    {
        mov eax, 2
        int 0x40
      mov result, eax
    }
    *keyCode = result;
    return (result);
    
}

void kos_ExitApp()
{
    __asm
    {
        or eax, -1
        int 0x40
    }
}

void draw_window(void)
{
    // start redraw
    kos_WindowRedrawStatus(1);
    // define&draw window
    kos_DefineAndDrawWindow(60, 50, 200, 50, 0x33, 0xFFFFFF, 0, 0, (Dword)header);
    // display string
    kos_WriteTextToWindow(30,10,0x80,0,(char*)string,0);
    // end redraw
    kos_WindowRedrawStatus(2);
}

void kos_Main(void)
{
    Byte keyCode;
    draw_window();
    for (;;)
    {
        switch (kos_WaitForEvent())
        {
            case 1:
                draw_window();
                break;
            case 2:
                // key pressed, read it and ignore
                kos_GetKey(&keyCode);
                break;
            case 3:
                // button pressed; we have only one button, close
                kos_ExitApp();
        }
    }
}
