#pragma once

#include "kos_func.h"
#include "kosSyst.h"
#include "mcsmemm.h"

#define SEEK_SET			0
#define SEEK_CUR			1

#define FILE_BUFFER_SIZE	512
#define OS_BLOCK_SIZE		1
#define FILE_BUFFER_BLOCKS	(FILE_BUFFER_SIZE / OS_BLOCK_SIZE)

/*
class CKosFile
{
public:
	CKosFile(char *fileName);
	virtual ~CKosFile(void);
	virtual int	Read(Byte *targetPtr, int readCount);
	virtual int Write(Byte *sourcePtr, int writeCount);
	virtual int Seek(int seekFrom, int seekStep);
protected:
	int filePointer;
	int bufferPointer;
	int validBuffer;
	kosFileInfo fileInfo;
	virtual void ValidateBuffer(void);
	virtual void UpdateBuffer(void);
};
*/
typedef struct CKosFile
{
	int filePointer;
	int bufferPointer;
	int validBuffer;
	int result;
	kosFileInfo fileInfo;
} CKosFile;

typedef CKosFile FILE;


#ifdef __cplusplus 
extern "C" {
#endif

void * malloc(int num);
void free(void *p);
double atof(const char *c);
int getc(FILE *f);
void ungetc(int c, FILE *f);
int fprintf(FILE*, const char *, ...);
int fflush(FILE*);
int strcmp(const char *, const char *);
int fclose(FILE*);
FILE* fopen(const char *, const char *);
int strncmp(const char *, const char *, int);
int unlink(const char *);
int memcmp(const void *, const void *, int);
int strncpy(char *, const char *, int);
void *realloc(void *, int);
int file_exists(const char *);
int fread(FILE *, void *, int);
int fwrite(FILE *, void *, int);
int fseek(FILE *, int, int);
int ftruncate(FILE *, int);
int fgetsize(FILE *);
int Kos_Sleep(int);

#ifdef __cplusplus 
}
#endif
