
#pragma once

#include "kos_func.h"

//typedef unsigned __int32 int;

#define NULL 0

#define MAX_PATH				256

#define FO_READ					0
#define FO_WRITE				2

#define EM_WINDOW_REDRAW		1
#define EM_KEY_PRESS			2
#define EM_BUTTON_CLICK			4
#define EM_APP_CLOSE			8
#define EM_DRAW_BACKGROUND		16
#define EM_MOUSE_EVENT			32
#define EM_IPC					64
#define EM_NETWORK				256

#define KM_CHARS				0
#define KM_SCANS				1

#define WRS_BEGIN				1
#define WRS_END					2

#define PROCESS_ID_SELF			-1

#define abs(a) ((a)<0?(0-(a)):(a))

double acos(double x);
double asin(double x);
double floor(double x);
double round(double x);
//#pragma function(acos,asin)
//#if _MSC_VER > 1200
//#pragma function(floor)
//#endif


typedef struct kosFileInfo
{
	Dword rwMode;
	Dword OffsetLow;
	Dword OffsetHigh;
	Dword dataCount;
	Byte *bufferPtr;
	char fileURL[MAX_PATH];
} kosFileInfo;

//typedef int int;


typedef struct RGB
{
	Byte b;
	Byte g;
	Byte r;

} RGB;
/*
	//
	RGB() {};
	//
	RGB( Dword value )
	{
		r = (Byte)(value >> 16);
		g = (Byte)(value >> 8);
		b = (Byte)value;
	};
	//
	int operator != ( RGB &another )
	{
		return this->b != another.b || this->g != another.g || this->r != another.r;
	};
	//
	int operator == ( RGB &another )
	{
		return this->b == another.b && this->g == another.g && this->r == another.r;
	};
};
*/


typedef union sProcessInfo
{
	Byte rawData[1024];
	struct
	{
		Dword cpu_usage;
		Word window_stack_position;
		Word window_stack_value;
		Word reserved1;
		char process_name[12];
		Dword memory_start;
		Dword used_memory;
		Dword PID;
		Dword x_start;
		Dword y_start;
		Dword x_size;
		Dword y_size;
		Word slot_state;
	} processInfo;
} sProcessInfo;

//
extern char *kosExePath;

//typedef int int;


#ifdef __cplusplus 
extern "C" {
#endif


//
void crtStartUp();
//
int __cdecl _purecall();
//
int __cdecl atexit( void (__cdecl *func )( void ));
//
void rtlSrand( Dword seed );
Dword rtlRand( void );
//
char * __cdecl strcpy( char *target, const char *source );
unsigned int __cdecl strlen( const char *line );
char * __cdecl strrchr( const char * string, int c );

/*
void * __cdecl memcpy( void *dst, const void *src, int bytesCount );
void memset( void *dst, Byte filler, Dword count );
#pragma intrinsic(memcpy,memset)
*/


void sprintf( char *Str, char* Format, ... );
//
Dword rtlInterlockedExchange( Dword *target, Dword value );
//  -1  
void kos_ExitApp();
//  0
void kos_DefineAndDrawWindow(
	Word x, Word y,
	Word sizeX, Word sizeY,
	Byte mainAreaType, Dword mainAreaColour,
	Byte headerType, Dword headerColour,
	Dword borderColour
	);
//  1  
void kos_PutPixel( Dword x, Dword y, Dword colour );
//  2    
int kos_GetKey( Byte *keyCode );
//  3  
Dword kos_GetSystemClock();
//  4
void kos_WriteTextToWindow(
	Word x, Word y,
	Byte fontType,
	Dword textColour,
	char *textPtr,
	Dword textLen
	);
//  7  
void kos_PutImage( RGB * imagePtr, Word sizeX, Word sizeY, Word x, Word y );
//  8  
void kos_DefineButton( Word x, Word y, Word sizeX, Word sizeY, Dword buttonID, Dword colour );
//  5 ,    
void kos_Pause( Dword value );
//  9 -   
Dword kos_ProcessInfo( sProcessInfo *targetPtr, Dword processID);
//  10
Dword kos_WaitForEvent();
//  11
Dword kos_CheckForEvent();
//  12
void kos_WindowRedrawStatus( Dword status );
//  13  
void __cdecl kos_DrawBar( Word x, Word y, Word sizeX, Word sizeY, Dword colour );
//  17
int kos_GetButtonID( Dword *buttonID );
//  23
Dword kos_WaitForEventT( Dword timeOut );
//
typedef enum eNumberBase
{
	nbDecimal = 0,
	nbHex,
	nbBin
} eNumberBase;
//     ""  37
void kos_GetMouseState( Dword * buttons, int * cursorX, int * cursorY );
//  40   
void kos_SetMaskForEvents( Dword mask );
//  47     
void kos_DisplayNumberToWindow(
   Dword value,
   Dword digitsNum,
   Word x,
   Word y,
   Dword colour,
   eNumberBase nBase,
   int valueIsPointer
   );
//  58    
Dword kos_FileSystemAccess( kosFileInfo *fileInfo );
//  63
void kos_DebugOutChar( char ccc );
//
void rtlDebugOutString( char *str );
//  64   ,  == -1  
void kos_ChangeWindow( Dword x, Dword y, Dword sizeX, Dword sizeY );
//  67   ,   
int kos_ApplicationMemoryResize( Dword targetSize );
//  66     
void kos_SetKeyboardDataMode( Dword mode );

//
void kos_Main();
Byte * AllocMemFromSystem( Dword reqSize );


void kos_InitHeap();

#ifdef __cplusplus 
}
#endif

